/***************************************************************
 * Name:      wxEEPROM_ALL
 * Purpose:   Code for Application Frame
 * Author:    seta43 ()
 * Created:   22/09/2020
 * Copyright: seta43 ()
 * Versión 1	22/09/2020
 * Para usar con eeprom.ino
 * xsetaseta@gmail.com
 *  seta43.duckdns.org
 **************************************************************/

#include "main.h"
#include "define.h"
#include "port.h"

#include "unistd.h"


char CLAVE[] = "PROM1";

#define MAXINPUT 100
int tiempo0=6,tiempo2=2;
unsigned char portok;
bool inicio=1;

int  ContadorI=0;
char Binput[MAXINPUT];
char Binput2[10];

char VARI[MAXINPUT];

    char CADE1[100]; 
    char CADE2[130];
    int val0,val1,val2;
    
unsigned char buffer[18000];
int direccion;
int OK_Dwrite;
int OK_Dread;
int OK_D32;

int MODE_B;
int WRITE_ON;
int LDROM_ON;
int NOLOAD_ON;
int contadorW;


int contadorB;
int contador16K;
int veri;

#define DATOSN 128
    
//_________________________

#if YesWindows
    static 	char *myport[]= {"com1","com2","com3","com4","com5","com6","com7","com8","com9","\\\\.\\COM10","\\\\.\\COM11","\\\\.\\COM12"};
#else
	static char *myport[]= {(char *)"/dev/ttyUSB0", (char *)"/dev/ttyUSB1", (char *)"/dev/ttyACM0", (char *)"/dev/ttyACM1", (char *)"/dev/ttyACM2", (char *)"/dev/ttyS0", (char *)"/dev/ttyS1"};
#endif	


DECLARE_APP(MiAplicacion)
// Give wxWidgets the means to create a MiAplicacion object
IMPLEMENT_APP(MiAplicacion)

BEGIN_EVENT_TABLE(eepromFrame,wxFrame)
 
END_EVENT_TABLE();



eepromFrame::eepromFrame(wxWindow* parent,wxWindowID id)
{
//(*Initialize(eepromFrame)
    Create(parent, wxID_ANY, _("GRABADOR EEPROM"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("wxID_ANY"));
    SetClientSize(wxSize(449,350));
    SetBackgroundColour(wxColour(241,241,105));
    StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("SST39SF020A  /  49F002"), wxPoint(8,16), wxDefaultSize, 0, _T("ID_STATICTEXT1"));
    StaticText1->SetForegroundColour(wxColour(36,49,226));
    StaticText1->SetBackgroundColour(wxColour(255,255,255));
    wxFont StaticText1Font(14,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText1->SetFont(StaticText1Font);
    StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("16384 Bytes"), wxPoint(320,16), wxSize(119,22), 0, _T("ID_STATICTEXT2"));
    StaticText2->SetForegroundColour(wxColour(196,30,30));
    StaticText2->SetBackgroundColour(wxColour(255,255,255));
    wxFont StaticText2Font(13,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText2->SetFont(StaticText2Font);
    StaticText3 = new wxStaticText(this, ID_STATICTEXT3, _("V7\nseta43"), wxPoint(352,216), wxDefaultSize, wxALIGN_CENTRE, _T("ID_STATICTEXT3"));
    StaticText3->SetForegroundColour(wxColour(133,31,31));
    wxFont StaticText3Font(14,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText3->SetFont(StaticText3Font);
    StaticText4 = new wxStaticText(this, ID_STATICTEXT4, _("Dirección"), wxPoint(16,88), wxDefaultSize, 0, _T("ID_STATICTEXT4"));
    wxFont StaticText4Font(10,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText4->SetFont(StaticText4Font);
    Info = new wxTextCtrl(this, ID_TEXTCTRL1, _("Grabador no encontrado"), wxPoint(16,48), wxSize(192,24), wxTE_READONLY, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    Info->SetForegroundColour(wxColour(32,71,45));
    wxFont InfoFont(8,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Info->SetFont(InfoFont);
    Bdireccion = new wxChoice(this, ID_CHOICE1, wxPoint(16,112), wxSize(96,32), 0, 0, 0, wxDefaultValidator, _T("ID_CHOICE1"));
    Bdireccion->SetSelection( Bdireccion->Append(_("0")) );
    Bdireccion->Append(_("16384"));
    Bdireccion->Append(_("32768"));
    Bdireccion->Append(_("49152"));
    Bdireccion->Append(_("65536"));
    Bdireccion->Append(_("81920"));
    Bdireccion->Append(_("98304"));
    Bdireccion->Append(_("114688"));
    Bdireccion->Append(_("131072"));
    Bdireccion->Append(_("147456"));
    Bdireccion->Append(_("163840"));
    Bdireccion->Append(_("180224"));
    Bdireccion->Append(_("196608"));
    Bdireccion->Append(_("212992"));
    Bdireccion->Append(_("229376"));
    Bdireccion->Append(_("245760"));
    BwriteRom = new wxButton(this, ID_BUTTON1, _("WRITE_ROM"), wxPoint(16,152), wxSize(136,33), 0, wxDefaultValidator, _T("ID_BUTTON1"));
    BsaveRom = new wxButton(this, ID_BUTTON2, _("SAVE_ROM"), wxPoint(16,192), wxSize(136,33), 0, wxDefaultValidator, _T("ID_BUTTON2"));
    BverifyFile = new wxButton(this, ID_BUTTON3, _("VERIFY_FILE"), wxPoint(16,232), wxSize(136,33), 0, wxDefaultValidator, _T("ID_BUTTON3"));
    Bconsola2 = new wxTextCtrl(this, ID_TEXTCTRL2, _(" "), wxPoint(16,272), wxSize(256,24), wxTE_READONLY, wxDefaultValidator, _T("ID_TEXTCTRL2"));
    wxFont Bconsola2Font(8,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Bconsola2->SetFont(Bconsola2Font);
    Bconsola = new wxTextCtrl(this, ID_TEXTCTRL3, _(" "), wxPoint(16,304), wxSize(224,24), wxTE_READONLY, wxDefaultValidator, _T("ID_TEXTCTRL3"));
    wxFont BconsolaFont(8,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Bconsola->SetFont(BconsolaFont);
    Bexit = new wxButton(this, ID_BUTTON4, _("EXIT"), wxPoint(344,296), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON4"));
    ProgressBar1 = new wxGauge(this, ID_GAUGE1, 100, wxPoint(328,112), wxDefaultSize, 0, wxDefaultValidator, _T("ID_GAUGE1"));
    ProgressBar2 = new wxTextCtrl(this, ID_TEXTCTRL4, _(" "), wxPoint(328,144), wxSize(104,33), 0, wxDefaultValidator, _T("ID_TEXTCTRL4"));
    wxFont ProgressBar2Font(12,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    ProgressBar2->SetFont(ProgressBar2Font);
    BverifyROM = new wxButton(this, ID_BUTTON5, _("LD"), wxPoint(120,112), wxSize(40,33), 0, wxDefaultValidator, _T("ID_BUTTON5"));
    BveriRom = new wxTextCtrl(this, ID_TEXTCTRL5, wxEmptyString, wxPoint(176,112), wxSize(48,33), wxTE_READONLY, wxDefaultValidator, _T("ID_TEXTCTRL5"));
    BveriRom->SetForegroundColour(wxColour(121,26,26));
    BveriL = new wxTextCtrl(this, ID_TEXTCTRL6, wxEmptyString, wxPoint(176,152), wxSize(48,33), wxTE_READONLY, wxDefaultValidator, _T("ID_TEXTCTRL6"));
    BveriL->SetForegroundColour(wxColour(191,18,18));
    TextBox3 = new wxTextCtrl(this, ID_TEXTCTRL7, _("file.rom"), wxPoint(176,192), wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL7"));
    BveriFichero = new wxTextCtrl(this, ID_TEXTCTRL8, wxEmptyString, wxPoint(176,232), wxSize(48,33), wxTE_READONLY, wxDefaultValidator, _T("ID_TEXTCTRL8"));
    BveriFichero->SetForegroundColour(wxColour(157,32,32));
    Bborrar = new wxButton(this, ID_BUTTON6, _("Clear EEPROM"), wxPoint(320,40), wxSize(112,33), 0, wxDefaultValidator, _T("ID_BUTTON6"));


    //*)
	Timer1.SetOwner(this, ID_TIMER1);
    Timer1.Start(10);

	Connect(ID_TIMER1,wxEVT_TIMER,(wxObjectEventFunction)&eepromFrame::OnTimer1Trigger);

    Connect(ID_BUTTON4,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&eepromFrame::OnBexitClick);
    Connect(ID_CHOICE1,wxEVT_COMMAND_CHOICE_SELECTED,(wxObjectEventFunction)&eepromFrame::OnBdireccionSelect);
    Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&eepromFrame::OnBwriteRomClick);
    Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&eepromFrame::OnBsaveRomClick);
    Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&eepromFrame::OnBverifyFileClick);
    Connect(ID_BUTTON5,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&eepromFrame::OnBverifyROMClick);
    Connect(ID_BUTTON6,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&eepromFrame::OnBborrarClick);
   

	
	openLed();

#if YesWindows 
  #if DEBUG
	AllocConsole();
	freopen("CON", "w", stdout); // redirects stdout
	freopen("CON", "w", stderr); // redirects stderr
  #endif
#endif
}



void eepromFrame::OnTimer1Trigger(wxTimerEvent& event)
{
	 int nbytes;
	 int bi;
	 wxString msg;
	 int z;
 
	tiempo0--; tiempo2--;
	if(tiempo0<0)
		{
		 tiempo0=300;
#if DEBUG 		 
		 printf("3Segundo\n");
#endif	
		}


	if(LDROM_ON==1)
			{
				LoadROM();
				LDROM_ON=0;
			}

		
	if(WRITE_ON==1 && OK_D32 ==0)
			{
				OK_D32 =1;
				writeSerieC('X'); writeSerieC(10);	
							
				for(z=0;z<32;z++)
								{
									bi=buffer[contadorW];							
									writeSerieC(bi); 
									contadorW++;
								}
				if( (contadorW%256)==0 )
					{								
						msg=wxString::Format(wxT("%i"),contadorW);												
						ProgressBar2->SetValue(msg);
						ProgressBar1->SetValue(contadorW/163);
					}
				if(contadorW>16383) 
					{
						WRITE_ON=0;
						printf("Escritos %d\n",contadorW);
						wxMessageDialog *dial1 = new wxMessageDialog(NULL, wxT("WRITE ROM"), wxT("Info"), wxOK);
						dial1->ShowModal();
					}
			}


//__________________________________________________
// cada 0,5 segundos
    if(portok==1 && tiempo2<0)
    {
        tiempo2=2;
#if YesWindows
						while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else
						while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif
							{
								
								switch(MODE_B)
								 {
									 case 0:								
										Binput[ContadorI]=Binput2[0];
										if(ContadorI<MAXINPUT-2)   ContadorI++;
		//								printf("Contador=%d %d  CHAR=%c\n",ContadorI,Binput2[0],Binput2[0]);
										if (Binput2[0] == '\n')
										   {
											if(ContadorI<2)ContadorI=2;
											Binput[ContadorI-1]=0;
											ContadorI=0;
											sprintf(VARI,"%s",Binput);
											//printf("==%s\n",VARI);			
											analizar();									
										   }
									break;
									
									case 1:
										//if(ORDEN_DI == 1) return;
										bi=Binput2[0];
										buffer[contadorB]=bi;
										veri = veri + bi;
										veri &= 255;
										contadorB++;
										contador16K++;
										if( (contador16K%1024)==0 )
											{
												ProgressBar1->SetValue(contador16K/163);
												msg=wxString::Format(wxT("%i"),contador16K);												
												ProgressBar2->SetValue(msg);
												//printf("%d\n",contadorB);
											}
										if(contadorB==16384)
											{
												MODE_B=0;
												msg=wxString::Format(wxT("%i"),veri);												
												BveriRom->SetValue(msg);
											}										
									break;
									
									case 2:
										
									
									break;
								   								   
								}  
								   
								   
							}
	}		
		
		
}


eepromFrame::~eepromFrame()
{
    if(portok==1)	{ portok=0;	 CloseRs232();	}   
    Close();
}



void eepromFrame::OnBexitClick(wxCommandEvent& event)
{
	if(portok==1)	{ portok=0;	 CloseRs232();	}   
    Close();
}


void eepromFrame::OnBdireccionSelect(wxCommandEvent& event)
{
	//printf("O_direccion\n");
	GotoDirec();
}

void eepromFrame::OnBverifyROMClick(wxCommandEvent& event)
{
	//printf("O_Verify_ROM\n");
	GotoDirec();
}

void eepromFrame::OnBborrarClick(wxCommandEvent& event)
{
   wxString msg;
			msg=wxT("CREAR ROM");
			wxMessageDialog dial(NULL, msg, wxT("Question"),   wxYES_NO | wxNO_DEFAULT | wxICON_QUESTION);
			if(dial.ShowModal()==wxID_YES)
				{
					printf("-CLEAR ROM\n");
					sprintf(CADE1,"ERASECHIP\n");
					SendData();
					wxMessageDialog *dial1 = new wxMessageDialog(NULL, wxT("CLEAR ROM"), wxT("Info"), wxOK);
					dial1->ShowModal();
				}
				else
				{
					printf("-Cancelado\n");
				}	
}


void eepromFrame::OnBwriteRomClick(wxCommandEvent& event)
{
  wxString CurrentDocPath;
  FILE *fp;
  char nombreFichero[90];
  int z;
  unsigned char bi;
  wxString msg;
    
	//printf("w_ROM\n");
	NOLOAD_ON=1;
	GotoDirec();
		
	wxFileDialog *openFileDialog=new wxFileDialog(this);
	if(openFileDialog->ShowModal()== wxID_OK)
	{
		CurrentDocPath = openFileDialog->GetPath();
		strcpy( nombreFichero, (const char*)CurrentDocPath.mb_str(wxConvUTF8) );
		//printf("FILE OPEN->%s\n",nombreFichero);
		if(!(fp=fopen(nombreFichero,"rb")))
		{
			printf("Error file write\n");
		}
		else
		{
			Bconsola2->SetValue(CurrentDocPath);
			veri=0;
			for(z=0;z<=16383;z++)
			{
				bi=getc(fp);
				buffer[z]=bi;
				veri+=bi;		veri &=255;
			}
			msg=wxString::Format(wxT("%i"),veri);
			BveriL->SetValue(msg);	
			fclose(fp);
						
			msg=wxT("WRITE ROM with ") + CurrentDocPath +wxT("  veri=")+ msg ;
			wxMessageDialog dial(NULL, msg, wxT("Question"),   wxYES_NO | wxNO_DEFAULT | wxICON_QUESTION);
			if(dial.ShowModal()==wxID_YES)
				{
					printf("-WRITE ROM\n");
					WRITE_ON=1;
					contadorW=0;
				}
				else
				{
					printf("-Cancelado\n");
				}							
		}
	}
			
}

void eepromFrame::OnBsaveRomClick(wxCommandEvent& event)
{
  FILE *fp;
  char nombreFichero[100];

  
	//printf("s_ROM\n");
	wxString msg=wxT("WRITE ") + TextBox3->GetValue() + wxT("  direccion=")+Bdireccion->GetStringSelection()+wxT("  veri=")+BveriRom->GetValue();
	wxMessageDialog dial(NULL, msg, wxT("Question"),   wxYES_NO | wxNO_DEFAULT | wxICON_QUESTION);
	if(dial.ShowModal()==wxID_YES)
	{
		sprintf(nombreFichero,"%s",(const char*)TextBox3->GetValue().mb_str());
		//printf(">%s<\n",nombreFichero);
		if(!(fp=fopen(nombreFichero,"wb")))
		{
			printf("Error file\n");
		}
		else
		{
			fwrite(buffer,1,16384,fp);  
			fclose(fp);
		}
	}
	else
	{
		printf("-Cancelado\n");
	}

}

void eepromFrame::OnBverifyFileClick(wxCommandEvent& event)
{
  wxString CurrentDocPath;
  FILE *fp;
  char nombreFichero[90];
  int z;
  unsigned char bi;
  wxString msg;
  
	//printf("f_ROM\n");
	wxFileDialog *openFileDialog=new wxFileDialog(this);
	if(openFileDialog->ShowModal()== wxID_OK)
	{
		CurrentDocPath = openFileDialog->GetPath();
		strcpy( nombreFichero, (const char*)CurrentDocPath.mb_str(wxConvUTF8) );
		//printf("FILE OPEN->%s\n",nombreFichero);
		if(!(fp=fopen(nombreFichero,"rb")))
		{
			printf("Error file verify\n");
		}
		else
		{
			Bconsola2->SetValue(CurrentDocPath);
			veri=0;
			for(z=0;z<=16383;z++)
			{
				bi=getc(fp);
				buffer[z]=bi;
				veri+=bi;		veri &=255;
			}
			msg=wxString::Format(wxT("%i"),veri);
			BveriFichero->SetValue(msg);	
			fclose(fp);
		}
	}
	
}


void eepromFrame::GotoDirec()
{
  char CADEX[90];
  wxString msg;
	if(portok == 1 )
		{
			msg=Bdireccion->GetStringSelection();			
			strcpy( CADEX, (const char*)msg.mb_str(wxConvUTF8) );
			sprintf(CADE1,"DI %s",CADEX);
			SendData();
			direccion=wxAtoi(msg);
			printf("direccion=%d\n",direccion);
		}
		else
		{
			printf("Port no abierto\n");
		}
		
}	


void eepromFrame::LoadROM()
{	
	//printf("Load_ROM\n");
	contador16K = 0;
    LoadROM16K();
}	

void eepromFrame::LoadROM1K()
{
 
	//printf("Load_rom1K\n");
	//Lectura ROM
}	

void eepromFrame::LoadROM16K()
{
  wxString msg;
	//printf("Load_rom16K\n");
	msg= wxString::FromUTF8("0");
	ProgressBar2->SetValue(msg);
	veri=0;
	contadorB = 0;
    MODE_B = 1;
	sprintf(CADE1,"L \n");	SendData();
	
	msg=wxString::Format(wxT("%i"),veri);
	BveriRom->SetValue(msg);	
}

void eepromFrame::analizar(void)
{
 wxString msg;
 int z;
    
    for(z=0;z<20;z++)  if(13==VARI[z]) { VARI[z]=0;  break; }
    if(0==strncmp(VARI,CLAVE,4))
		{
			printf("OK_%s\n",CLAVE);
			Bconsola->SetValue(_("GRABADOR ENCONTRADO"));
			goto salirAna;
		}	
    	
    if(0==strncmp(VARI,"DK",2))
		{
			msg= wxString::FromUTF8(VARI);
			Bconsola->SetValue(msg+_("<"));
			if(NOLOAD_ON==0)	LDROM_ON=1;
			NOLOAD_ON=0;
			goto salirAna;
		}
	if(0==strncmp(VARI,"x",1))
		{
			OK_D32 = 0;
			goto salirAna;
		}	
 salirAna:
 ;		
}



void eepromFrame::SendData(void)
{
  sprintf(CADE2,"%s\n",CADE1);
#if DEBUG 
    printf("%s",CADE2);
#endif
    if(portok==1) PrintSerial(CADE2);
}




//__________________________________
int eepromFrame::SearchPort2(void)
{
	int z,zz,nbytes;
	int  ContadorI=0;
	char Binput[MAXINPUT];
	char Binput2[10];
	
 #if YesWindows
		for (z=0;z<11;z++)
 #else
			for (z=0;z<7;z++)
 #endif
			{
				MODEMDEVICE=myport[z];
				printf("Test Port %s\n",MODEMDEVICE);			
				if(0==IniRs232())
				   {
					printf("OK %s\n",MODEMDEVICE);	
					DelayMs(700);
					ContadorI=0;
					for(zz=0;zz<20;zz++)
					   {
						DelayMs(100);
#if YesWindows
						while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else
						while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif
							{
								Binput[ContadorI]=Binput2[0];
								if(ContadorI<MAXINPUT-2)   ContadorI++;
								if (Binput2[0] == '\n')
								   {
									if(ContadorI<2)ContadorI=2;
									Binput[ContadorI-1]=0;
									ContadorI=0;
									if(!strncmp(Binput,CLAVE,5))
									   {
										printf("%s found at %s\n",CLAVE,MODEMDEVICE);
										CloseRs232();
										return z ;
									   }									
								    }
							}
						}

					}
			 }
	printf("%s no found \n",CLAVE);
	return -1;
}



int eepromFrame::openLed(void)
{
  int z;
  wxString msg;
		if(inicio==1)
		{
			inicio=0;
			z=SearchPort2();
		if(z==-1)
			 {
				 portok=0;
				 printf("No %s\n",CLAVE);
				 msg.Printf(wxT("No encontrado PROM1"));
				 wxMessageBox(msg, wxT("ERROR"), wxOK | wxICON_INFORMATION, this);
				 msg.Printf(wxT("No port"));
				 Info->SetValue(msg);
				 return -1;
			 }
			else
		     {

			MODEMDEVICE=myport[z];
			#if YesWindows
				if(hSerial)CloseRs232();
			#else
				if(fdrs232)CloseRs232();
			#endif
									
			#if DEBUG     
				printf("Init\n");
			#endif
			#if YesWindows
				if(hSerial)CloseRs232();
			#else 
				if(fdrs232)CloseRs232();    
			#endif
			
			if(0==IniRs232())
						{
							msg= wxString::FromUTF8(MODEMDEVICE);
							Info->SetValue(msg+_(" ")+_("115200,0,8,1"));      
							printf("SI %s\n",MODEMDEVICE);									    
							portok=1;
						}																		
			 }		 
		}							
 return 0;
}

